;
; zieht schraege text-phong lines
; IN                               
; ax=xa                                
; bx=ya                                                        
; cx=xe                            
; dx=ye                                                        
; si=ecke1                                    
; di=ecke2                                    
;
linietext_phong:
	pushad                                                                          
	mov   	xa,ax                           
	mov 	ya,bx                           
	mov 	xe,cx                           
	mov 	ye,dx                           
	mov 	ecke1,si       
	mov 	ecke2,di       
                                                               
	mov 	ax,ya
	cmp 	ax,ye                           
	jle 	@nichttauschen_text_phong
	mov 	bx,ye                           
	mov 	ya,bx                           
	mov 	ye,ax                                          
	mov 	ax,xa                           
	mov 	bx,xe                                          
	mov 	xa,bx                           
	mov 	xe,ax          
	mov 	ax,ecke1       
	mov 	bx,ecke2        
	mov 	ecke1,bx        
	mov 	ecke2,ax        
@nichttauschen_text_phong: 
	xor	ebp,ebp
	mov 	bp,ye
	sub 	bp,ya
 	jz 	@ende_text_phong
	movzx 	esi,ecke1      
	movzx 	edi,ecke2      
;phong anfang                                 
	mov	bh,[normrotx+esi]
	xor	bl,bl            
	mov	ah,[normrotx+edi]
	xor	al,al          
	sub	ax,bx                                          
	cwd                    
	idiv	bp   
	shrd	dummydword1,eax,16
 	mov	bh,[normroty+esi] 
	xor	bl,bl             
	mov	ah,[normroty+edi] 
	xor	al,al             
	sub	ax,bx             
 	cwd                       
 	idiv	bp                
	mov	w dummydword1,ax  
 	mov	bh,[normrotx+esi] 	  	
	xor	bl,bl                                          
	shl  	ebx,16                          
	mov    	bh,[normroty+esi]               
;texture anfang      
	mov    	ch,[xtex+esi]
	xor	cl,cl        
	mov	ah,[xtex+edi]
	xor	al,al        
	sub	ax,cx        
	cwd                       
	idiv	bp                                      
	shrd	dummydword2,eax,16                      
	mov	ch,[ytex+esi]                           
	xor 	cl,cl                                   
	mov	ah,[ytex+edi]                           
	xor	al,al                                   
	sub	ax,cx                                   
	cwd                                             
	idiv	bp                                      
	mov	w dummydword2,ax
 	mov	ch,[xtex+esi] 	  	
	xor	cl,cl
	shl  	ecx,16
	mov    	ch,[ytex+esi]
;texture ende                                                        
	movsx 	eax,xe                                  
	sal  	eax,9   
	movsx 	edi,xa                                         
	sal 	edi,9                                          
	sub   	eax,edi                                        
	mov	edx,eax                                        
	sar	edx,31                                         
	idiv 	ebp                                            
	mov 	dummydword,eax              ;edi=xfaktor       
	movsx 	edi,ya                                         
	movsx 	esi,xa                                 
	sal 	esi,9               ;ebp=xstartwert*256
@next_text_phong:                                                             
	       	add   	esi,dummydword             ;inc(x,dx)           
	   	mov   	eax,esi                                         
 	   	sar  	eax,9
	  	add    	ebx,dummydword1     ;phong addi 
	  	add	ecx,dummydword2     ;texture addi
	   	cmp  	edi,yviewmin                                                                                                                        
		jl  	@nichtspeichern_text_phong                                    
		cmp 	edi,yviewmax                                    
		jg 	@ende_text_phong                                      
		cmp 	ax,[links+edi*2]                                
	     	jnl 	@rechts_text_phong
     		@links_text_phong:        
      	   	  	mov  	[links+edi*2],ax
		  	mov  	[linksny+edi*2],bx
		  	mov  	[linkstexy+edi*2],cx
		  	rol 	ebx,16              
			rol 	ecx,16		    	
			mov 	[linksnx+edi*2],bx      
		       	mov 	[linkstexx+edi*2],cx
		     	rol 	ebx,16              
		     	rol 	ecx,16              
		@rechts_text_phong:                       
		cmp 	ax,[rechts+edi*2]           
		jng 	@nichtspeichern_text_phong        
		   	mov  	[rechts+edi*2],ax   
			mov  	[rechtsny+edi*2],bx 
			mov  	[rechtstexy+edi*2],cx
			rol 	ebx,16               
			rol 	ecx,16              
	 	   	mov 	[rechtsnx+edi*2],bx  
		   	mov 	[rechtstexx+edi*2],cx
		   	rol    	ebx,16               
		   	rol    	ecx,16              
	@nichtspeichern_text_phong:                                
		inc 	edi                                  
		cmp 	di,ye                                  
	  	jl 	@next_text_phong                           
@ende_text_phong:                                                  
	popad                                                  
ret                                                 

xa	dw ?                 
ya	dw ?                        
xe	dw ?                 
ye	dw ?                                     
ecke1 	dw ?                 
ecke2	dw ?                 

rundrum:
   	pushad              
	mov	ecx,20 	    
	sub	ecx,eax              
	shr	ecx,1       
	mov	ebp,eax     
	mov  	eax,320     
	movzx	edx,word ptr [ebx+2]
	add	edx,ecx         
	mul 	edx                   
	add 	ax,word ptr [ebx]
	add	eax,ecx     
	add	edi,eax     
	add	esi,eax     
	mov	edx,edi     
	mov	ebx,ebp     
	mov	eax,ebx     
	mov	ebp,esi         
	shr	ebx,2       
rundrumloop:                
       	mov 	ecx,ebx     
     	rep     movsd       	     			
	add	edx,320     
	mov	edi,edx                                 
	add	ebp,320     
	mov	esi,ebp                                 
	dec	eax                                     
	jnz   	rundrumloop          
 	popad                        
ret                                                             
                                     
blasen:
        lea 	edi,texture
        mov	ecx,16000  
        mov	eax,-1     
        rep	stosd      
        lea 	esi,texture       
        mov    	edi,video
   	lea	ecx,schnecki
	mov	edx,ecx              
	mov	ebp,ecx              
	add	ebp,640         
blasenloop:                          
	xor	eax,eax              
	mov	ebx,ecx              
blasloop:                            
        add  	eax,4                
     	sub	ebx,4       
	cmp	ebx,edx              
 	jl 	keinrundrum 
 	cmp	ebx,ebp     
 	jg 	keinrundrum 
      	call 	rundrum               
keinrundrum:                          
 	cmp	eax,20                
 	jl 	blasloop              
     	add	ecx,4      
      	call	waitdisplay
      	call	waitretrace
       	cmp	ecx,660    
       	jl 	blasenloop 
ende:     
ret                                       
