.586   
.model flat
public enable    
public disable   
public switchon
public switchoff
public verknuepfungsart
public waitretrace
public waitdisplay
public bildbreite
public aktiveadresse
public startadresse
public extrafarbe
public extrafarbelesen
public punkt
public punktfarbe
public paletteschreiben
public palettelesen
public bildladen
public bildladenneu
public filespeichern
public fileladen
public fileladen_neu
public modus     
public textmodus
public enter100
public leave100
public enter400
public leave400
public tastenaus
public tastenein
public readkey  
public keypressed
public exitdos
public wurzel
public X360Y240
public X320Y200
public X320Y240
public X360Y200
public X376Y282
public X320Y400
public X320Y480
public X360Y400 
public X360Y480     
public X360Y360
public X376Y308
public X376Y564
public X256Y240
public X256Y200
public settime
public gettime
public printHEX
public PrintDEC

;variablen
public seite
public video
public xbreite
public ybreite
public bbreite
public rot       
public gruen     
public blau      
public ze           
public speicher
.code          
align 4
 MISC_OUTPUT equ 3c2h
 SC_Index    equ 3c4h
 CRTC_Index  equ 3d4h
 seite dd (?)   
 video dd ?
 xbreite dw (?) 
 ybreite dw (?) 
 bbreite dw (?) 
 rot   db (?)       
 gruen db (?)  
 blau  db (?)  
 ze    db (?)  
 position dd 0 
 xende dw 0    
 x dw 0        
 y dw 0        
 speicher dd 0
 tastenint df 0
               
;
; enable
; IN -
; OUT -
;
enable:
 push dx ax
 mov  dx,3c4h
 mov  ax,0f02h
 out  dx,ax
 mov  dx,3ceh
 mov  ax,4105h
 out  dx,ax
 pop  ax dx
ret
                
;
; disable
; IN -
; OUT -
;
disable:
 push dx ax
 mov  dx,3c4h
 mov  ax,0f02h  
 out  dx,ax
 mov  dx,3ceh
 mov  ax,4005h
 out  dx,ax
 pop  ax dx
ret
;
; switchon
; IN -
; OUT -         
;
switchon:
 push edx eax
 call waitretrace
 mov  dx,3c4h
 mov  al,1 
 out  dx,al
 inc  dx   
 in   al,dx
 and  al,0dfh   
 out  dx,al
 pop  eax edx
ret        
           
;
; switchoff
; IN -
; OUT -
;
switchoff:      
 push dx ax
 mov  dx,3c4h
 mov  al,1
 out  dx,al
 inc  dx
 in   al,dx
 or   al,20h
 out  dx,al
 pop  ax dx
ret             

;
; verknuepfungsart
; IN - ah verknuepfungsart
; OUT -
;
verknuepfungsart:
 push dx ax cx
 mov  dx,3ceh
 mov  al,3h     
 mov  cl,3
 shl  ah,cl
 out  dx,ax
 pop  cx ax dx
ret

;
; waitretrace
; IN -
; OUT -         
;
waitretrace:
 push dx ax
waitretraceloop:
 mov  dx,03dah
 in   ax,dx
 and  ax,8h
 or   ax,ax
 jnz  waitretraceloop
 pop ax dx      
ret

;
; waitdisplay
; IN -
; OUT -
;
waitdisplay:
 push dx ax
waitdisplayloop:
 mov  dx,03dah
 in   ax,dx
 and  ax,8h
 or   ax,ax
 jz   waitdisplayloop
 pop  ax dx
ret

;
; bildbreite    
; In:bx=xbreite
; Out:
;
bildbreite:
 push dx bx ax
 mov  dx,3d4h
 mov  al,13h
 out  dx,al
 inc  dx
 shr  bx,2
 mov  bbreite,bx
 shr  bx,1
 mov  al,bl
 out  dx,al
 pop  ax bx dx
ret

;
; aktiveadresse
; IN - eax=y,ebx=x
; OUT - seite wird gesetzt
;
aktiveadresse:
 push ebx eax
 mul  bbreite
 shr  ebx,2
 add  eax,ebx
 add  eax,video
 mov  seite,eax
 pop  eax ebx
ret

;
; startadresse
; IN - ax=y,ebx=x
; OUT - vgaregs werden gesetzt
;
startadresse:
 push ax bx dx
 mul  bbreite   
 shr  bx,2
 add  bx,ax
 mov  dx,3d4h
 mov  al,0ch
 out  dx,al
 inc  dx
 mov  al,bh
 out  dx,al
 dec  dx
 mov  al,0dh
 out  dx,al
 inc  dx
 mov  al,bl
 out  dx,al
 pop  dx bx ax
ret

;
; setzt farbe mit den rot gruen blau werten
; In:           
;   al - farbe
;   ah - rotwert
;   bl - gruenwert
;   bh - blauwert
;
extrafarbe:
  push dx ax
  mov  dx,03c8h
  out  dx,al
  mov  dx,03c9h
  mov  al,ah
  cli
  out  dx,al
  mov  al,bl
  out  dx,al
  mov  al,bh
  out  dx,al
  sti
  pop  ax dx
ret             
                
;
; extrafarbelesen
; IN - al,farbe
; OUT - rot,gruen,blau= globale variablen
;
extrafarbelesen:
	push	dx ax
	mov	dx,3c7h
	out	dx,al
	mov	dx,3c9h
	cli
	in	al,dx
	mov	rot,al
	in	al,dx
	mov	gruen,al
	in	al,dx
	sti
	mov	blau,al
	pop	ax dx
ret             
        
;
; punkt 
; IN - eax=y,bx=x,ch=farbe
; OUT - punkt wird im modex gesetzt, seite muss gesetzt sein
;
punkt:        
	pushad
	mov	cl,bl
	mul	bbreite
	shr	bx,2
	add	ax,bx
	movzx	edi,ax
	add	edi,seite
	and	cl,3
	mov	ah,1
	shl	ah,cl
	mov	al,2
	mov	dx,3c4h
	out	dx,ax
	mov	[edi],ch
	popad
ret           
              
;
; punktfarbe  
; IN - eax=y,bx=x
; OUT - al=farbe
;
punktfarbe:   
	pushad
	mov	cl,bl
	mul	bbreite
	shr	bx,2
	add	ax,bx
	movzx	edi,ax
	add	edi,seite
	and	cl,3
	mov	ah,cl
	mov	al,4
	mov	dx,3ceh
	out	dx,ax
	mov	al,[edi]
	popad
ret

;
; paletteschreiben
; IN - al=start,ah=ende,esi=startadr von palette
; OUT -      
;
paletteschreiben:
	pushad
	sub	ah,al
	mov	ch,ah
	movzx	eax,al
	add	esi,eax
	add	esi,eax
	add	esi,eax
	mov	cl,-1
nextcolor:      
	inc	cl
	mov	al,cl
	mov	ah,[esi]
	mov	bl,[esi+1]
	mov	bh,[esi+2]
	call	extrafarbe
	add	esi,3
	cmp	cl,ch
	jne	nextcolor
	popad
ret          
                 
;
; paletteschreiben
; IN - al=start,ah=ende,ebp=startadr von palette
; OUT -                    
;
paletteschreiben1:
	pushad             
	sub	ah,al      
	mov	ch,ah      
	movzx	eax,al     
	add	ebp,eax
	add	ebp,eax
	add	ebp,eax
	mov	cl,-1
nextcolor33:        
	inc	cl        
	mov	al,cl     
	mov	ah,[ebp]
	mov	bl,[ebp+1]
	mov	bh,[ebp+2]
	call	extrafarbe
	add	ebp,3
	cmp	cl,ch     
	jne	nextcolor33
	popad      
ret                
                   
;
; palettelesen
; IN - al=start,ah=ende,esi=startadr von palette
; OUT - rot,gruen,blau= globale variablen
;
palettelesen:
	pushad
	sub	ah,al
	movzx	cx,ah
	movzx	eax,al
	add	esi,eax
	add	esi,eax
	add	esi,eax
nextcolor1:     
	mov	al,cl
	call	extrafarbelesen
	mov	al,rot
	mov	[esi],al
	mov	al,gruen
	mov	[esi+1],al
	mov	al,blau
	mov	[esi+2],al
	add	esi,3
	dec	cx
	jns	nextcolor1
	popad
ret     
        
;
; bildladen
; IN -  eax = gre
;        cl = bildinfo(j/n) bit 0
;        cl = palsetzen bit 1
;       edx = palzeiger
;       edi = wohin(bei edi=0 gilt modex),
;       esi = woher
; OUT -
;
bildladen:
	pushad                 
	mov	ebx,[esi]
	cmp	ebx,134284554
	jne	beginbildladen
	mov	bl,[esi+64]
	cmp	bl,1           ;anzebenen
	jne	beginbildladen
	jmp	endebildladen
beginbildladen: 
	   	mov	bx,[esi+8]
		inc	bx
	      	mov	xende,bx
		mov	x,0
		mov	y,0
		mov	ebx,esi
		add	ebx,eax
		sub	ebx,768
		mov	position,ebx
	 	dec	ebx
		mov	al,[ebx]
		cmp	al,12  
		jne	endebildladen
		inc	ebx
		xor	ch,ch
bildpalette:            
		mov	ax,[ebx]
		shr	ah,2
		shr	al,2
		mov	[edx],ax  
		mov	al,[ebx+2]
		shr	al,2    
		mov	[edx+2],al
		add	ebx,3   
		add	edx,3
		inc	ch
		jnz	bildpalette
		add	esi,128
		cmp	cl,2
		jb	bildladenhaupt
		mov	ax,0ff00h
		push	esi    
		sub	edx,768
		mov	esi,edx
		call	paletteschreiben
		pop	esi
		and	cl,11111101b
bildladenhaupt:  ; ch=farbe,dh=faktor
		mov	ch,[esi]  
		mov	dh,1
		cmp	ch,193
		jb	bildfaktor
		sub	ch,192
		mov	dh,ch
		inc	esi
bildfaktor:             
		mov	ch,[esi]
		mov	dl,1
bildsetzen:             
		cmp	edi,0
		jnz	nichtmodex  ; ansonsten modex-punkt
		movzx	eax,y  
		mov	bx,x
		call	punkt
		jmp	naechsterpunkt
nichtmodex:             
		cmp	cl,0        ; bildinfo ?
		jz	nichtbildinfo
		movzx	eax,y
		push	dx
		mul	xende
		pop	dx
		add	ax,x
		mov	[edi+eax],ch
		jmp	naechsterpunkt
nichtbildinfo:          
		movzx	eax,y
		mov	ebx,eax
		shl	ax,6
		shl	bx,8
		add	ax,bx
		add	ax,x   
		mov	[edi+eax],ch
naechsterpunkt:         
		inc	x
		mov	ax,xende
		cmp	x,ax      
		jne	altezeile
		mov	x,0
		inc	y            
altezeile:              
		dec	dh
		jnz	bildsetzen
		inc	esi
		cmp	esi,position
		jne	bildladenhaupt
endebildladen:          
	popad
ret

; ebp = groesse                                                                          
; esi = woher                                                                            
; edi = wohin                                                                            
      pal db 768 dup (?)             
 hicolorpuffer dw 2000 dup (?)       
 bytespro dw (?)                     
bildladenneu:                        
	pushad             
      	mov    	eax,[esi]            
     	cmp   	eax,134284555	;kennung vergleichen {10,5,1,1}
     	jz  	bits4  	     	;bei al=1 kann nur noch 4 oder 1 bit sein                
        cmp	eax,134284554                                                            
        jnz	endebildladenneu                                                         
hicolor:                                                       
     	mov  	al,byte ptr [esi+65]                                                     
	cmp  	al,1                                                                     
	jz 	bits8  	                                                                 
	                                                                                 
	lea	ecx,hicolorpuffer                                                        
 	xor	ebx,ebx                                                                  
	xor	edx,edx                                                                  
        mov	dx,[esi+66]                                                              
	mov	bytespro,dx   	                                                         
	add	ebp,esi                                                                  
	add	esi,128                                                                  
hibildentpack: 	                                                                         
  	cmp 	esi,ebp                                                                  
	jz 	endebildladenneu
hirote:                         
     	mov 	bl,[esi]     
  	cmp	bl,193                                                     
 	jb 	hieinrotpunkt  	; if puffer[zaehler] >= 193 then                         
	sub	bl,192 	      	; faktor:=puffer[zaehler]-192; bl=faktor                 
	   	       	       	; farbe:=puffer[zaehler+1]  bh=farbe                     
	mov	al,[esi+1]
	add	esi,2   
  	jmp	hischieberot                                                             
hieinrotpunkt:                                                                                
	inc	esi              
	mov	al,bl            
	mov	bl,1             
hischieberot:                    
     	shl 	ax,11            
       	sub	dx,bx            
hirotpuffer:                      
  	mov    	[ecx],ax                                                                 
        inc	ecx              
      	dec	bl               
	jnz	hirotpuffer      
        cmp	dx,0             
 	jnz	hirote 	         
                      
       	mov	dx,bytespro      
      	sub	ecx,edx          
higruene:  	    
     	mov 	bl,[esi]                                                                 
	cmp	bl,193                                                                   
 	jb 	hieingruenpunkt ; if puffer[zaehler] >= 193 then                 
	sub	bl,192 	       	; faktor:=puffer[zaehler]-192; bl=faktor                 
	   	       	       	; farbe:=puffer[zaehler+1]  bh=farbe                     
	xor	ax,ax                                                                    
	mov	al,[esi+1]
	add	esi,2
  	jmp	hischiebegruen                                                           
hieingruenpunkt:                                                                         
	inc	esi                                                                      
	mov	al,bl                                                                    
	mov	bl,1                                                                     
hischiebegruen:                                                                          
  	shl 	ax,6                                                                     
	sub	dx,bx                                                                    
higruenpuffer:                                                                           
	add	ax,[ecx]                                                                 
       	mov 	[ecx],ax                                                                 
        inc	ecx                                                                      
       	dec	bl                                                                       
	jnz	higruenpuffer                                                            
 	cmp	dx,0                                                                     
	jnz	higruene	                                                         
                                                                                         
 	mov	dx,bytespro                                                              
  	sub	ecx,edx                                                                  
hiblaue: 	                                                                         
     	mov 	bl,[esi]                                                                 
  	cmp	bl,193                                                                   
 	jb 	hieinblaupunkt   	; if puffer[zaehler] >= 193 then                 
	sub	bl,192 	      	; faktor:=puffer[zaehler]-192; bl=faktor                 
	   	       	       	; farbe:=puffer[zaehler+1]  bh=farbe                     
	xor	ax,ax                                                   
	mov	al,[esi+1]
	add	esi,2
  	jmp	vorhiblaupuffer                                         
hieinblaupunkt:                                                         
	inc	esi
	mov	al,bl                                                   
      	mov    	bl,1                                                    
vorhiblaupuffer:                                                        
	sub	dx,bx                                                   
hiblaupuffer:                                                           
	add  	ax,[ecx]
       	mov 	[ecx],ax
        inc	ecx             
       	dec	bl                                                      
	jnz	hiblaupuffer                                            
	cmp	dx,0                                                    
        jnz 	hiblaue                                                                  
                                                                        
 	mov	dx,bytespro                                             
	sub	ecx,edx    
hicolorpuffersetzen:                                                    
	mov  	ax,[ecx]   
 	stosw              
 	inc	ecx        
     	dec	dx         
        jnz	hicolorpuffersetzen
	mov	dx,bytespro
	sub	ecx,edx                       
 	jmp	hibildentpack                                           
bits8:                                                                                   
        add	ebp,esi                                                                  
	add	esi,128                                                                  
        sub	ebp,768                                                                  
        xor	ebx,ebx                                                                  
neubildpalette:                                                                             
        mov	ax,[ebp]                                                                 
    	shr	ah,2                                                                     
	shr	al,2                                                     
	mov 	[ebp],ax                                                 
	mov     al,[ebp+2]                                               
	shr	al,2                                                     
	mov	[ebp+2],al                                               
	add	ebp,3                                                    
	inc	bl                                                       
 	jnz	neubildpalette                                              
	sub	ebp,768                                                  
       	mov	ax,0ff00h         
        call	paletteschreiben1
neubildentpack: 	                                                                         
   	cmp	esi,ebp         
	jz 	endebildladenneu
	mov	bx,word ptr [esi]
 	mov	al,bh           
	mov	ah,bl           
 	cmp	ah,193           
 	jb 	einpunkt     	; if puffer[zaehler] >= 193 then                         
	sub	ah,192 	     	; faktor:=puffer[zaehler]-192; bl=faktor                 
	   	       	    	; farbe:=puffer[zaehler+1]  bh=farbe                     
   	add	esi,2  	     	; inc(zaehler,2);                                        
 	jmp	neubildsetzen                                                               
einpunkt:                                                                                
 	mov	al,ah  	    	; farbe:=puffer[zaehler];
      	mov	ah,1   	  	; faktor:=1                                              
    	inc 	esi    	     	; inc(zaehler);                                          
neubildsetzen:     	                                                                         
        stosb	                                                                                 
   	dec  	ah                                                                               
   	jnz	neubildsetzen    	; for zaehler1:=1 to faktor do mem[$a000:y*320+x]:=farbe;
       	jmp  	neubildentpack                                                                      
bits4:                                                                                           
 	mov    	bl,byte ptr [esi+65]            
 	cmp	bl,4   	    	; bei gleich 4 muss es 4bit sein,sonst 1bit
        jne	bits1                           
    	jmp	endebildladenneu        	
bits1:                             
 	jmp	endebildladenneu
endebildladenneu:  
	popad   
ret                               

;
; filespeichern                   
; IN - edx=zeiger auf dateiname   
;      ebx=woher aus ram          
;      ecx=anzahl in bytes        
;
filespeichern:              
;file anlegen (in edx zeiger auf dateiname)
      	pusha               
	push	ecx
	mov	ecx,0
	mov	ax,3C00h             ; Create a file
	int    	21h                  ; filehandle in ax               
	jc 	endefilespeichern    ; exit if error                  
;schreibt speicher in die datei (ab speicheradresse edx, ecx-bytes)      
	pop	ecx                                                      
	mov   	edx,ebx              ;zeiger auf daten in dx          
        mov     bx,ax                ;filehandle in bx             
        mov     ax,4000h                                           
	int	21h                                                
	jc	endefilespeichern                                                    
;schliet die datei                                                
       	mov 	ah,3Eh                                             
	int 	21h                                                
endefilespeichern:                                                 
	popa                                                       
ret                                                                
                                                                   
;
; fileladen                                                        
; IN - edx=zeiger auf dateiname                     
; OUT - eax=filesize ,edx zeigt auf file im ram     
;
fileladen:                                          
;file ffnen (bergabe in edx zeiger auf dateiname)
	push	ebx ecx
	mov	ax,3D00h             ; Open the file mit read only (al=00h)
	int	21h
	jc 	endefileladen        ; exit if error
	mov	bx,ax                               
;filesize bestimmen                                 
	xor	edx,edx
	xor	ecx,ecx
	Mov	ax,4202h             ; springt zum ende
	Int	21h
	Jc 	endefileladen        ; exit if error
	push	eax
	push	eax
	Mov	ax,4200h             ; springt zum anfang
	Int	21h
	pop	edx
	mov	ecx,edx              ;rette in ecx anzahl bytes
;reserviert speicherplatz in hhe von dateigre (pop eax in edx)
	mov	ax,0EE42h
	int	31h                  ; returns EDX = offset of block
	jc	endefileladen        ; jump if error
;liest die datei in den speicher (ab speicheradresse  ecx-bytes)
	mov	ah,3Fh
	int	21h                  ; Read file
;schliet die datei
 	mov	ah,3Eh
	int	21h
	pop   	eax
endefileladen:           
   	pop  	ecx ebx
ret                    
                       
;
; fileladenohnegetmem  
; IN - edx=zeiger auf dateiname
; OUT - eax=filesize ,edx zeigt auf file im ram     
;
fileladen_neu:                 
;file ffnen (bergabe in edx zeiger auf dateiname)
	push 	ebx ecx
	mov  	ax,3D00h             ; Open the file mit read only (al=00h)
	int	21h            
	jc 	endefileladen_neu        ; exit if error
	mov	bx,ax                               
;filesize bestimmen                                 
	xor	edx,edx        
	xor	ecx,ecx        
	Mov	ax,4202h             ; springt zum ende
	Int	21h            
	Jc 	endefileladen_neu        ; exit if error
	push	eax              
	push	eax              
	Mov	ax,4200h             ; springt zum anfang
	Int	21h              
	pop	edx            
	mov	ecx,edx              ;rette in ecx anzahl bytes
;reserviert speicherplatz in hhe von dateigre (pop eax in edx)
	mov	edx,speicher	       		;esi=abwo schreiben
;	mov	ax,0EE42h                                  
; 	int	31h                  ; returns EDX = offset of block
; 	jc	endefileladen        ; jump if error       
;liest die datei in den speicher (ab speicheradresse  ecx-bytes)
	mov	ah,3Fh           
	int	21h                  ; Read file
;schliet die datei              
 	mov	ah,3Eh           
	int	21h              
	pop   	eax         
	mov	edx,speicher
	add	speicher,eax
endefileladen_neu:                   
   	pop	ecx ebx 
ret                                                        
                                                           
                                                               
X360Y240 label                                                 
 db 0e7h                                                       
 db 16                                                         
 dw 06b00h
 dw 05901h
 dw 05a02h
 dw 08e03h
 dw 05e04h
 dw 08a05h
 dw 00d06h
 dw 03e07h
 dw 04109h
 dw 0ea10h
 dw 0ac11h
 dw 0df12h
 dw 00014h
 dw 0e715h
 dw 00616h
 dw 0e317h
 dw 360
 dw 240


X320Y200 label
 db 00     ;0e3h dot clock
 db 02     ;Number of CRTC Registers to update
 dw 00014h ;turn off dword mode
 dw 0e317h ;turn on byte mode
 dw 320    ;width
 dw 200    ;height

X320Y240 label
 db 0e3h   ;dot clock
 db 10     ;Number of CRTC Registers to update
 dw 00d06h ;vertical total
 dw 03e07h ;overflow (bit 8 of vertical counts)
 dw 04109h ;cell height (2 to double-scan)
 dw 0ea10h ;v sync start
 dw 0ac11h ;v sync end and protect cr0-cr7
 dw 0df12h ;vertical displayed
 dw 00014h ;turn off dword mode
 dw 0e715h ;v blank start
 dw 00616h ;v blank end
 dw 0e317h ;turn on byte mode
 dw 320    ;width
 dw 240    ;height

X360Y200 label
 db 0e7h   ;dot clock
 db 08     ;Number of CRTC Registers to update
 dw 06b00h ;horz total
 dw 05901h ;horz displayed
 dw 05a02h ;start horz blanking
 dw 08e03h ;end horz blanking
 dw 05e04h ;start h sync
 dw 08a05h ;end h sync
 dw 00014h ;turn off dword mode
 dw 0e317h ;turn on byte mode
 dw 360    ;width
 dw 200    ;height

X376Y282 label
 db 0e7h
 db 18
 dw 06e00h ;horz total
 dw 05d01h ;horz displayed
 dw 05e02h ;start horz blanking
 dw 09103h ;end horz blanking
 dw 06204h ;start h sync
 dw 08f05h ;end h sync
 dw 06206h ;vertical total
 dw 0f007h ;overflow
 dw 06109h ;cell height
 dw 0310fh
 dw 03710h ;v sync start
 dw 08911h ;v sync end and protect cr0-cr7
 dw 03312h ;vertical displayed
 dw 02f13h ;offset
 dw 00014h ;turn off dword mode
 dw 03c15h ;v blank start
 dw 05c16h ;v blank end
 dw 0e317h ;turn on byte mode
 dw 376
 dw 564

X320Y400 label
 db 00      ;0e3h dot clock
 db 03      ;Number of CRTC Registers to update
 dw 04009h  ;cell height
 dw 00014h  ;turn off dword mode
 dw 0e317h  ;turn on byte mode
 dw 320     ;width
 dw 400     ;height

X320Y480 label
 db 0e3h   ;dotclock
 db 10     ;Number of CRTC Registers to update
 dw 00d06h ;vertical total
 dw 03e07h ;overflow (bit 8 of vertical counts)
 dw 04009h ;cell height (2 to double-scan)
 dw 0ea10h ;v sync start
 dw 0ac11h ;v sync end and protect cr0-cr7
 dw 0df12h ;vertical displayed
 dw 00014h ;turn off dword mode
 dw 0e715h ;v blank start
 dw 00616h ;v blank end
 dw 0e317h ;turn on byte mode
 dw 320    ;width
 dw 480    ;height

X360Y400 label
 db 0e7h   ;dot clock
 db 09     ;Number of CRTC Registers to update
 dw 06b00h ;horz total
 dw 05901h ;horz displayed
 dw 05a02h ;start horz blanking
 dw 08e03h ;end horz blanking
 dw 05e04h ;start h sync
 dw 08a05h ;end h sync
 dw 04009h ;cell height
 dw 00014h ;turn off dword mode
 dw 0e317h ;turn on byte mode
 dw 360    ;width
 dw 400    ;height

X360Y480 label
 db 0e7h
 db 17
 dw 06b00h ;horz total
 dw 05901h ;horz displayed
 dw 05a02h ;start horz blanking
 dw 08e03h ;end horz blanking
 dw 05e04h ;start h sync
 dw 08a05h ;end h sync
 dw 00d06h ;vertical total
 dw 03e07h ;overflow
 dw 04009h ;cell height
 dw 0ea10h ;v sync start
 dw 0ac11h ;v sync end and protect cr0-cr7
 dw 0df12h ;vertical displayed
 dw 02d13h ;offset
 dw 00014h ;turn off dword mode
 dw 0e715h ;v blank start
 dw 00616h ;v blank end
 dw 0e317h ;turn on byte mode
 dw 360
 dw 480

X360Y360 label
 db 0e7h
 db 15
 dw 06b00h ;horz total
 dw 05901h ;horz displayed
 dw 05a02h ;start horz blanking
 dw 08e03h ;end horz blanking
 dw 05e04h ;start h sync
 dw 08a05h ;end h sync
 dw 04009h ;cell height
 dw 08810h ;v sync start
 dw 08511h ;v sync end and protect cr0-cr7
 dw 06712h ;vertical displayed
 dw 02d13h ;offset
 dw 00014h ;turn off dword mode
 dw 06d15h ;v blank start
 dw 0ba16h ;v blank end
 dw 0e317h ;turn on byte mode
 dw 360
 dw 360

X376Y308 label
 db 0e7h
 db 18
 dw 06e00h ;horz total
 dw 05d01h ;horz displayed
 dw 05e02h ;start horz blanking
 dw 09103h ;end horz blanking
 dw 06204h ;start h sync
 dw 08f05h ;end h sync
 dw 06206h ;vertical total
 dw 00f07h ;overflow
 dw 04009h
 dw 0310fh
 dw 03710h ;v sync start
 dw 08911h ;v sync end and protect cr0-cr7
 dw 03312h ;vertical displayed
 dw 02f13h ;offset
 dw 00014h ;turn off dword mode
 dw 03c15h ;v blank start
 dw 05c16h ;v blank end
 dw 0e317h ;turn on byte mode
 dw 376
 dw 308

X376Y564 label
 db 0e7h
 db 18
 dw 06e00h ;horz total
 dw 05d01h ;horz displayed
 dw 05e02h ;start horz blanking
 dw 09103h ;end horz blanking
 dw 06204h ;start h sync
 dw 08f05h ;end h sync
 dw 06206h ;vertical total
 dw 0f007h ;overflow
 dw 06009h
 dw 0310fh
 dw 03710h ;v sync start
 dw 08911h ;v sync end and protect cr0-cr7
 dw 03312h ;vertical displayed
 dw 02f13h ;offset
 dw 00014h ;turn off dword mode
 dw 03c15h ;v blank start
 dw 05c16h ;v blank end
 dw 0e317h ;turn on byte mode
 dw 376
 dw 564

X256Y240 label
 db 0e3h   ;dot clock
 db 16     ;Number of CRTC Registers to update
 dw 05f00h ;horz total
 dw 03f01h ;horz displayed
 dw 04202h ;start horz blanking
 dw 09f03h ;end horz blanking
 dw 04c04h ;start h sync
 dw 00005h ;end h sync
 dw 00d06h ;vertical total
 dw 03e07h ;overflow (bit 8 of vertical counts)
 dw 04109h ;cell height (2 to double-scan)
 dw 0ea10h ;v sync start
 dw 0ac11h ;v sync end and protect cr0-cr7
 dw 0df12h ;vertical displayed
 dw 00014h ;turn off dword mode
 dw 0e715h ;v blank start
 dw 00616h ;v blank end
 dw 0e317h ;turn on byte mode
 dw 256           
 dw 240           
                  
X256Y200 label    
 db 0e3h   ;dot clock
 db 8      ;Number of CRTC Registers to update
 dw 05f00h ;horz total
 dw 03f01h ;horz displayed
 dw 04202h ;start horz blanking
 dw 09f03h ;end horz blanking
 dw 04c04h ;start h sync
 dw 00005h ;end h sync
 dw 00014h ;turn off dword mode
 dw 0e317h ;turn on byte mode
 dw 256
 dw 200                                   

;
; modus
; IN - esi=offset von videomodus 
; OUT -                                   
;
modus:                                    
	pushad                            
	mov	ax,13h                    
	int	10h                       
	mov	dx,SC_INDEX               
	mov	ax,0604h                  
	out	dx,ax                     
	mov	ax,0100h                  
	out	dx,ax                     
	mov	al,[esi]                  
	inc	esi                       
	or	al,al                     
	jz	@@DontSetDot              
	mov	dx,MISC_OUTPUT            
	out	dx,al
@@DontSetDot:   
	mov	dx,SC_INDEX
	mov	ax,0300h
	out	dx,ax
	mov	dx,CRTC_INDEX
	mov	al,11h
	out	dx,al
	inc	dx
	in	al,dx
	and	al,07fh
	out	dx,al
	dec	dx
	cld
	xor	cx,cx
	mov	al,[esi]
	inc	esi
	mov	cl,al
@@SetCRTParmsLoop:
	mov	ax,[esi]                  
	add	esi,2
	out	dx,ax
	dec	cx 
	jne	@@SetCRTParmsLoop
	mov	ax,[esi]
	add	esi,2
	mov	xbreite,ax
	mov	cx,ax
	mov	ax,[esi]  
	add	esi,2     
	mov	ybreite,ax
	mov	dx,SC_INDEX
	mov	ax,0f02h  
	out	dx,ax     
                          
	shr	cx,2      ;<-xbreite shr 2
	mov	bbreite,cx                
	shr	cx,1                      
	mov	dx,CRTC_INDEX             
	mov	al,13h                    
	mov	ah,cl                     
	out	dx,ax                     
                                          
	mov	edi,video                 
	sub	eax,eax                   
	mov	ecx,16384                 
	rep	stosd                     
	popad                             
ret                                       
                                          
;
; textmodus                               
; In:-                                    
; Out:-                                   
;
textmodus:                                
	push	eax                        
	mov	ax,3h                     
	int	10h                       
 	pop	eax                        
ret              
                 
;
; enter100       
; In:-           
; Out:-          
;
enter100:        
	push	dx ax
	mov	dx,3d4h
	mov	al,9
	out	dx,al
	inc	dx
	in	al,dx
	or	al,10000000b
	out	dx,al
	pop	ax dx
ret             

;
; leave100
; In:-
; Out:-
;
leave100:
	push	dx ax
	mov	dx,3d4h
	mov	al,9
	out	dx,al
	inc	dx
	in	al,dx
	and	al,01111111b
	out	dx,al
	pop	ax dx
ret             
                
;
; enter400      
; In:-          
; Out:-         
;
enter400:       
	push	dx ax
	mov	dx,3d4h
	mov	al,9
	out	dx,al
	inc	dx
	in	al,dx
	and	al,01110000b
	out	dx,al
	pop	ax dx
ret             

;
; leave400
; In:-
; Out:-
;
leave400:
	push	dx ax
	mov	dx,3d4h
	mov	al,9
	out	dx,al
	inc	dx
	in	al,dx
	and	al,10001111b
	out	dx,al
	pop	ax dx
ret             

;
; readkey
; In:-   
; Out:schreibt zeichen in ze (global)
;
readkey:
	push	ax
	xor	ax,ax
	int	16h
	mov	ze,al
	cmp	al,0
	jnz	readkeyexit
	mov	ze,ah
readkeyexit:    
  	pop	ax
ret              
                
;
; keypressed
; In:-      
; Out:carry on/off
;
keypressed:
	push	ax
	clc       
	mov	ah,0bh
	int	21h
	cmp	al,0
	jz	keypressedweiter
	stc       
keypressedweiter:                
     	pop	ax               
ret                              
                                 
tasten:                          
      	push    ax
      	mov	al,20h
 	out	20h,al
      	in   	al,60h
      	cmp     al,01             
	je      esctaste          
	pop	ax
	iret                      
	esctaste:                     
	pop	ax
	jmp 	cs:tastenint      
                                  
;
; tastenaus                       
; In:-                           
; Out:-                          
;
tastenaus:                       
	cli                      
	mov	al,36h           
	out	43h,al           
	mov	al,169           
	out	40h,al           
	mov	al,4             
	out	40h,al                  
                                        
	mov	bl,9                    ; BL = int number.
	mov	ax,0204h                
	int	31h                     ; Call the service.
	mov	dword ptr tastenint,edx ; Save vector as a 48 bit far
	mov	word ptr tastenint+4,cx  ;  pointer.
                                        
	mov	bl,9                    ; BL = int number
	mov	edx,offset tasten       ; EDX = offset of int vector
	mov	cx,cs                   ; CX = selector value
	mov	ax,0205h                
	int	31h                     ; Call the service.
                                        
	sti                             
ret                                     
                                        
;
; tastenein                             
; In:-                                  
; Out:-                                 
;
tastenein:                              
	cli                             
	mov	al,36h                  
	out	43h,al                  
	xor	al,al                   
	out	40h,al                  
	out	40h,al                  
                                        
	mov	bl,9                    ; BL = int number
	mov	edx,dword ptr tastenint ; Get vector as a 48 bit far
	mov	cx,word ptr tastenint+4
	mov	ax,0205h         
	int	31h                     ; Call the service.
                                 
	sti                      
ret                  
                        
;
; exitdos               
; In:-                  
; Out:-                 
;
exitdos:                
      	mov	ax,4c00h
	int	21h     
ret                     
                        
;
; berechnet wurzel
; IN ebx - zahl 
; OUT bx - wurzel
;
wurzel:         
	push	eax ecx edx esi
	xor	esi,esi
	xor	edx,edx
	mov	ecx,ebx
	mov	eax,ebx
iteratwurzel:   
		idiv	ebx
		xor	edx,edx
		add	eax,ebx
		shr	eax,1
		sub	esi,eax
		cmp	esi,1
		jbe	fertigwurzel
		mov	esi,eax
		mov	ebx,eax
		mov	eax,ecx
		jmp	iteratwurzel
fertigwurzel:           
	mov	bx,ax
	pop	esi edx ecx eax
ret                      
                         
;
; settime setzt zeit auf 00:00:00.00
; In:-               
; Out:-              
;
settime:             
	push	ecx edx eax 
	mov	ah,2dh      
	xor	cx,cx       
	mov	dx,cx       
	int	21h         
   	pop	eax edx ecx    
ret             
                
                
;
; gettime gibt zeit in sekunden zurueck
; In:-          
; Out:- ax = anzahl der sekunden
;
gettime:        
	push	ecx edx esi   
	mov	ah,2ch     
	int	21h        
	movzx	si,dh     
	mov	ax,60      
	xor	ch,ch      
	mul	cx         
	add	ax,si      
	movzx	eax,ax    
	pop	esi edx ecx   
ret                      


dec_divider dd 1,10,100,1000,10000,100000,1000000,10000000,100000000,1000000000
digit       dd 0

PrintDEC:
	pushad
	mov	esi,4*5
	mov	ecx,eax
        xor     ebp,ebp
divloop:        
        mov     eax,ecx
        xor     edx,edx
        div     dec_divider[esi]
        mov     ecx,edx                     ; reuse remainder
        or      ebp,ebp                     ; skip leading zeros
        jnz     valid_DECnumber
        or      esi,esi                     ; last zero has to be printed
        jz      valid_DECnumber
        or      al,al
        jz      @@dec1
valid_DECnumber:     
        inc     ebp  
        add     al,'0'                      ; use quotient as digit number
        mov     dl,al
        mov     ah,2 
        int     21h  
@@dec1:
        sub     esi,4
        jge     divloop
        popad      
ret                
                   
                   
                   
printHEX:
        pushad  
        mov     [digit],eax
        mov     ecx,8
        xor     ebp,ebp
rolloop:        
        rol     [digit],4
        mov     al,byte PTR [digit]
        and     al,0fh
        cmp     al,10
        jb      j8
        add     al,'A'-'0'-10
        or      ebp,ebp                     ; number needs leading zero if its first >=10
        jnz     valid_HEXnumber
        push    eax
        mov     dl,'0'                      ; the leading zero
        mov     ah,02h
        int     21h
        pop     eax
j8:  
        or      ebp,ebp                     ; skip leading zeros
        jnz     valid_HEXnumber
        or      al,al
        jz      @@hex1
valid_HEXnumber:     
        inc     ebp  
        add     al,'0'
        mov     dl,al    
        mov     ah,02h   
        int     21h      
@@hex1:                  
        loop    rolloop  
        or      ebp,ebp  
        jnz     @@hex2   
        mov     ah,2     
        mov     dl,'0'   
        int     21h      
@@hex2:                  
        mov     dl,'h'   
        int     21h      
        popad            
ret                      

end